#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <numeric>
using namespace std;
//=====================================================
// int MakeQRec(int n,int **r, int n_not_simple=0,int nI=10);
//=====================================================
int MakeQ(int **m,int n,int nSub=0);
int MakeQPrime(int **m,int n,int nSub);
int MakeQRec(int n,int **r, int n_not_simple=0,int nI=10);
#define swap(a,b) {ttt=(a);(a)=(b);(b)=ttt;}
inline char **allocate_2D_Array(int m,int n_, int size_of_element,int set_clear=0)
{int i;char **p;int size,n=(n_+7)/8*8;
 p=(char**)new char[size=m*sizeof(char*)+m*n*size_of_element];
 if(set_clear)for(i=0;i<size;i++)((char*)p)[i]=0;
	p[0]=((char*)p)+m*sizeof(char*);
	for(int i=1;i<m;i++)
	{
		p[i]=p[i-1]+n*size_of_element;
	}
return p;
}

int MakeQ(int **m,int n,int nSub)
{int i,j,k,NStep=0; int x,N,v; 
 if(nSub>0)
 {int k,l;int t;
  if(n%nSub!=0){printf("MakeQ: n=%d nSub=%d\n",n,nSub);getchar(); exit(-1); return -1;}
  int **m1=(int**)allocate_2D_Array(n/nSub,n/nSub,sizeof(int),1);
  int **m2=(int**)allocate_2D_Array(nSub,nSub,sizeof(int),1);
  MakeQ(m1,n/nSub);
  MakeQ(m2,nSub);
  for(i=0;i<n/nSub;i++)for(j=0;j<n/nSub;j++)
  {
   for(k=0;k<nSub;k++)for(l=0;l<nSub;l++)
    m[i*nSub+k][j*nSub+l]=m2[k][l]+m1[i][j]*nSub;
  }
  //printM("m not prime:",m,n);
  for(int I=0;I<20;I++)
  {
   i=rand()%n;j=rand()%n;
   for(k=0;k<n;k++)for(l=0;l<n;l++)
    if(m[k][l]==i)m[k][l]=-1;
   for(k=0;k<n;k++)for(l=0;l<n;l++)
    if(m[k][l]==j)m[k][l]=i; else if(m[k][l]==-1)m[k][l]=j;
   for(k=0;k<n;k++)
   {t=m[k][i];m[k][i]=m[k][j];m[k][j]=t;}
   for(k=0;k<n;k++)
   {t=m[i][k];m[i][k]=m[j][k];m[j][k]=t;}
  }
  delete[] (char*)m1; m1=NULL; delete[] (char*)m2; m2=NULL;
  return 0;
 }
 char *used=new char[n];
 for(NStep=1;;NStep++)
 {
  for(i=0;i<n;i++)for(j=0;j<n;j++)m[i][j]=0;
  for(i=0;i<n;i++)
  {
   for(j=0;j<n;j++)
   {
    memset(used,0,n);
    for(k=0;k<i;k++)used[m[k][j]]=1;
    for(k=0;k<j;k++)used[m[i][k]]=1;
    for(N=0,k=0;k<n;k++)if(!used[k])N++;
    if(N==0)
     goto lc;
    x=rand()%N;
    for(v=0,k=0;k<n;k++)if(!used[k])
    {
     if(x==v)
     {m[i][j]=k;used[k]=1;break;}
     v++;
    }
   }
  }
  i=i;
  if(i==n&&j==n)
   break;
  lc:;
 }
delete[] used; used=NULL;
return NStep;
}

int MakeQRec(int n,int **r, int n_not_simple,int nI)
{int ttt,n0=8,I,i,j,k,o,p,nn,nnOld,**m=(int**)allocate_2D_Array(n,n,sizeof(int),1);
 //if(rand()%2)
 // for(nnOld=8,nn=8;nn<=n;nn=(nn*8<=n?nn*8:nn*2<=n?n:nn*2))
 // {n0=nn/nnOld;nnOld=nn;}
 // printf("n0=%d\n",n0);
 if(n<=8)
 {
  MakeQ(r,n,0);
  return 0;
 }
 int in0=rand()%3;
 if(in0==0)n0=2;else if(in0==1)n0=4;else in0=8;
 for(nn=n0;nn<=n;nn=(nn*8<=n?nn*8:nn*2<=n?n:nn*2))
 {
  if(nn==n0)
  {
   MakeQ(r,nn,0);
   if(nn!=n_not_simple)
   {
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[i][k],r[j][k]);}
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[k][i],r[k][j]);}
   }
  }
  else
  {int n2=nn/nnOld;
   //if(n2<=1||n2>8){printf("(464243) n2=%d\n",n2);exit(-1);}
   MakeQ(m,n2,0);
   for(i=0;i<nn;i+=nnOld)
    for(j=(i==0?nnOld:0);j<nn;j+=nnOld)
    {
     for(o=0;o<nnOld;o++)
      for(p=0;p<nnOld;p++)
       r[i+o][j+p]=r[o][p]+m[i/nnOld][j/nnOld]*nnOld;
    }
   i=0;j=0;
    {
     for(o=0;o<nnOld;o++)
      for(p=0;p<nnOld;p++)
       r[i+o][j+p]=r[o][p]+m[i/nnOld][j/nnOld]*nnOld;
    }
   if(nn!=n_not_simple)
   {
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[i][k],r[j][k]);}
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[k][i],r[k][j]);}
   }
  }
  nnOld=nn;
 }
 return 0;
}
