#pragma once
//#define USE_NOP
#define __MPI__
//#define __OMP__
#ifdef __MPI__
#include <mpi.h>
#endif
#ifdef __OMP__
#include <omp.h>
#endif
#include <stdlib.h>
#include <iostream>
#include <stdio.h>
#include <string.h>
#ifndef WIN32
#include <unistd.h>
#endif
#include <math.h>
#include <algorithm>
#include <numeric>
#include <time.h>
using namespace std;
//#define __CUDA__
#define IN
#define OUT
void FTestPrimCudaJ(int J,  IN int n,IN int **q,IN int **qt, IN char *tmp_mem, IN int (*list_)[2], IN char *set_ab_, /*OUT char *SetJ,*/ OUT int *nSub);
int CheckSimple1(int **r,int **rt,int n);
int MakePreclass0(int **r,int **rt,int n, int J, int *nSub);
//-------------
void FTestPrimOMP2(int J,IN int n,IN int **q, OUT int *SetJ, OUT char *SetNoPrime=NULL);
void FTestPrimOMP(int J,IN int n,IN int **q, IN char **eq_used2, IN int (*list_)[2], IN int (*list1_)[2], OUT char *SetJ);
void FTestPrim(int J,IN int n,IN int **q,IN int **qt, IN char *tmp_mem, IN int (*list_)[2], IN int (*list1_)[2], IN char *set_ab_, OUT char *SetJ);
//-------------
int CheckNotPrime(int **r,int **gr,int ngr,int n);
//-------------
int FTestAffinX(int i0,int istep,int n,int **L);
int FTestAffinX(int n,int **L);
int TestAffine0(int order,int **r);
int FTestAffin(int n,int **L,int **L1,int **L2,int **tmp_ptr);
int FTestAffin(int i0,int i1,int n,int **L,int **L1,int **L2,int **tmp_ptr);
int FTestAffin1(int n,int **L,int **L1,int **L2,int **tmp_ptr);
int FTestAffin2(int n,int **L,int **L1,int **L2,int **tmp_ptr);
int FTestAffin3(int n,int **L,int **L1,int **L2,int **tmp_ptr);
inline char **allocate_2D_Array_gpu(int m,int n, int size_of_element,int set_clear=0)
{m=m;n=n;size_of_element=size_of_element;set_clear=set_clear;return NULL;
}
inline char **allocate_2D_Array_gpu_correct(char **p,int m,int n_, int size_of_element)
{size_t n=(n_+7)/8*8;
	p[0]=((char*)p)+m*sizeof(char*);
	for(int i=1;i<m;i++)
	{
		p[i]=p[i-1]+n*size_of_element;
	}
return p;
}
inline char **allocate_2D_Array_gpu_correctS(char **p,int m,int n_, int size_of_element,int set_clean=0)
{size_t n=(n_+7)/8*8;
 if(set_clean)
 {
  memset(p,0,m*sizeof(char*)+n*((size_t)size_of_element)*m);
 }
	p[0]=((char*)p)+m*sizeof(char*);
	for(int i=1;i<m;i++)
	{
		p[i]=p[i-1]+n*size_of_element;
	}
//	printf("size total=%d",(int)(m*sizeof(void*)+m*n*size_of_element));exit(0);
return p;
}
inline char **allocate_2D_Array(int m,int n_, int size_of_element,int set_clear=0)//,void *NULL_VALUE=NULL)
{int i;char **p;int n=(n_+7)/8*8; size_t size;
 p=(char**)new char[size=m*sizeof(char*)+m*(size_t)n*size_of_element];
 //p=(char**)((((int)p)+31)/32*32);
 if(set_clear)for(i=0;i<(int)size;i++)((char*)p)[i]=0;//memset(p,0,size);
	p[0]=((char*)p)+m*sizeof(char*);
	for(int i=1;i<m;i++)
	{
		p[i]=p[i-1]+n*size_of_element;
	}
return p;
}
//------------------------------------
template <class Type> class AutoFree
{
 public:
  AutoFree():ptr(NULL){};
  AutoFree(Type *p):ptr(p){};
  ~AutoFree()
   {
    if(ptr)//&&*ptr)
     {
      delete [] ptr;
      ptr=NULL;
     };
   };
  void own(Type *p)
   {
    ptr=p;
   };
 private:
  Type *ptr;
};
//------------------------------------
template<class T> T Max(T a,T b){if(a<b)return b; return a;}
template<class T> T Min(T a,T b){if(a>b)return b; return a;}
template<class T> T Abs(T a){if(a>=0)return a; return -1;}
void printM(int **m,int n,const char *sf=NULL);
void printM(char **m,int n,const char *sf=NULL);
void printMN(int **m,int n);
void printMN(char **m,int n);
inline void printM(const char *s,int **m,int n,const char *sf=NULL){printf("%s\n",s);printM(m,n,sf);}
inline void printM(const char *s,char **m,int n,const char *sf=NULL){printf("%s\n",s);printM(m,n,sf);}
inline void printMN(const char *s,int **m,int n){printf("%s\n",s);printMN(m,n);}
inline void printMN(const char *s,char **m,int n){printf("%s\n",s);printMN(m,n);}

int check_latin(int **m,int n,int *i_=NULL,int *j_=NULL);
void ShowGroups(const char *str, int (*list)[2],int n);

int CheckPrimeEasy(int **m,int n,int *c=NULL);
int MakeQ(int **m,int n,int nSub=0);
int MakeQPrime(int **m,int n,int nSub);

int WaitStart();
int CheckStop();
int SetStop();
int SendStart(int i);
int SendStop(int i);
extern int SetMPIStart,SetMPIStop,MPIrank;

#define E1 {FILE *f=fopen(strcat(strcpy(ErrFile,OutputFile),".err"),"a"); if(f){
#define E2 fclose(f);}else {printf("Can't open error file");return -1;}}
#define O1 {FILE *f=fopen(OutputFile,"a"); if(f){
#define O2 fclose(f);}else {printf("Can't open output file");}}
extern char ErrFile[256];//="out.txt.err";
extern char OutputFile[256];
inline int r8(int n){return (n+7)/8*8;}
int MakeQRec(int n,int **r, int n_not_simple=0,int nI=20);
void SwapR(int **r,int n,int i0,int i1);
extern long long NOP;
