#ifndef _SIMPLE_H_
#define _SIMPLE_H_

struct wpair {
	unsigned int first;
	unsigned int second;
	struct wpair *prev;
	struct wpair *next;
};

typedef struct wpair wpair_t;

typedef struct wpair* wpair_list_t;

void wpair_list_init (wpair_list_t *l);
void wpair_list_deinit (wpair_list_t *l);
int wpair_list_add (wpair_list_t *l, unsigned int first, unsigned int second);
void wpair_list_remove (wpair_list_t *l, wpair_t *wpair);

struct eqclass {
	unsigned int rep;
	struct eqclass *next;
	struct eqclass *last;
};

typedef struct eqclass eqclass_t;

struct eqclass_list {
	eqclass_t *head;
	eqclass_t *tail;
};

typedef struct eqclass_list eqclass_list_t;

void eqclass_list_init (eqclass_list_t *l);
void eqclass_list_deinit (eqclass_list_t *l, int do_free);
int eqclass_list_add (eqclass_list_t *l, unsigned int num);
void eqclass_list_remove (eqclass_list_t *l, eqclass_t *eqclass);
void eqclass_list_merge (eqclass_list_t *l, eqclass_list_t *l2);

int read_ls (const char *file, unsigned int **ls, int *order);
void print_ls (unsigned int *ls, int order);

int is_simple (unsigned int *ls, int order);

#endif
